const LODASH_NAMES = [
   '_un','_nu','_t','_f',
   "_B","_N","_S","_BI","_Y",
   "_A","_F","_P","_X","_J","_O","_R",

   "_MP","_ST",
   "_WMP","_WST","_WREF", 

   "_RE","_DT",
   "_AB","_BUF",
   "_U8A","_U8CA","_U16A","_U32A",
   "_I8A","_I16A","_I32A",
   "_F32A","_F64A",
   "_BU64A","_BI64A", 

   "_DV", 
   "_EV","_EVT", 

   "_URL","_URLSRCHP",
       "_decd_url","_decd_url_com",
       "_encd_url","_encd_url_com",
   "_ATOM",

   "_ER", "_AGGER", "_EVLER", "_REFER", "_RNGER", "_STXER", "_TYPER", "_URIER",

   "_FREG",

   "_ABRT_CTRL","_ABRT_SIG",
   "_MSG_CHAN", "_MSG_PORT","_MSGEV",

   "_TXTENCD","_TXTDECD",

   "_WASM",

   "_MATH",
     
   "_infi",   "_nan",
   "_is_fin", "_is_nan",
   "_parse_f","_parse_i",

   "_INTL","_PERF",

   "_cnsl","_cryp",
   "_html_esc","_html_unesc", 
   "_clr_intvl","_set_intvl", 
   "_clr_tmout","_set_tmout",
   "_q_micro_tsk", 

   "_fs","_path","_buf", 
]


const NO_LODASH_NAMES = [
   "eval","atob","btoa"
]

const _fs       = require("fs");
const _path     = require("path");
const {apend_fmt_sary} = require("nv-string-basic");


const G_CODE = `const _G = globalThis;` 

const mirr     = ()=> {
    let md = {}
    for(let name of LODASH_NAMES) {
        let content = _fs.readFileSync(_path.join(__dirname,"ir",name)+".js").toString();
        content = content.replace(new RegExp(name,'g'),'');
        content = content.replace(/=/g,'');
        content = content.replace(/[ ]+/g,'');
        content = content.replace(/;/g,'');
        content = content.trim();
        md[name] = content;
        md[content] = name
    }
    return(md)
}

const slct     = (ary=[])=> {
    let rslt = []
    for(let e of ary) {
        for(let each of LODASH_NAMES) {
            if(each.includes(e)) {
                rslt.push(each)
            }
        }
    }
    let fmted_names = apend_fmt_sary(rslt);
    for(let i=0;i<rslt.length;i++) {
        let name = rslt[i];
        let content = _fs.readFileSync(_path.join(__dirname,"ir",name)+".js").toString();
        content = content.replace(new RegExp(name,'g'),'');
        content = content.trim();
        content = fmted_names[i] + ' ' + content;
        content = '_G.'+content;
        rslt[i] = "      "+content;
    }
    rslt.unshift(G_CODE);
    return(rslt.join("\n"))
}

const list  = ()=> {
    let arr = apend_fmt_sary(LODASH_NAMES);
    return(arr.join("\n"))
}

module.exports = {
    LODASH_NAMES,
    NO_LODASH_NAMES,
    slct,
    list,
    mirr,
}
